"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .streamedchatchoice import StreamedChatChoice, StreamedChatChoiceTypedDict
from .usage import Usage, UsageTypedDict
from friendli.types import BaseModel
from typing import List, Literal, Optional
from typing_extensions import NotRequired, TypedDict


StreamedChatResultObject = Literal["chat.completion.chunk"]
r"""The object type, which is always set to `chat.completion.chunk`."""


class DataTypedDict(TypedDict):
    choices: List[StreamedChatChoiceTypedDict]
    created: int
    r"""The Unix timestamp (in seconds) for when the token sampled."""
    id: NotRequired[str]
    r"""A unique ID of the chat completion."""
    object: NotRequired[StreamedChatResultObject]
    r"""The object type, which is always set to `chat.completion.chunk`."""
    usage: NotRequired[UsageTypedDict]


class Data(BaseModel):
    choices: List[StreamedChatChoice]

    created: int
    r"""The Unix timestamp (in seconds) for when the token sampled."""

    id: Optional[str] = None
    r"""A unique ID of the chat completion."""

    object: Optional[StreamedChatResultObject] = None
    r"""The object type, which is always set to `chat.completion.chunk`."""

    usage: Optional[Usage] = None


class StreamedChatResultTypedDict(TypedDict):
    r"""A server-sent event containing chat completions content."""

    data: DataTypedDict


class StreamedChatResult(BaseModel):
    r"""A server-sent event containing chat completions content."""

    data: Data
